<?php
/*
 * @component jOpenSim
 * @copyright Copyright (C) 2020 FoTo50 http://www.jopensim.com/
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
defined('_JEXEC') or die();

require_once(JPATH_COMPONENT_SITE.DIRECTORY_SEPARATOR.'models'.DIRECTORY_SEPARATOR.'opensim.php');

class opensimModelInterfaceMessages extends OpenSimModelOpenSim {
// ###############################################
// ########## offline message functions ##########
// ###############################################

	public function saveMessage($data) {
		error_log("here I am ;) (Zeile ".__LINE__.")");
		$functionblock = "Offline Messages";
		$retval = "";
		$debug = var_export($this->settings,TRUE);
//		error_log("Settings: ".$debug." (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->simpledebugzeile("[SaveMessage] fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);
		if($this->settings['addons_messages'] == 0) {
			if($this->debug['messages'] == "1") $this->simpledebugzeile("Offline Messages disabled!",$functionblock);
			return "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
		}
		$message = $this->opensim->parseOSxml($data['input']);
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->debugzeile($message,"message",$functionblock);
		$searchstr = "?".">";
		$start = strpos($data['input'], $searchstr);
		if($this->debug['messages'] == "1") $this->simpledebugzeile("\nstart:\n".$start,$functionblock);
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if ($start != -1) {
			$start+=2;
			$msg = substr($data['input'], $start);
			if($this->debug['messages'] == "1") $this->simpledebugzeile("\nmsg:\n".$msg,$functionblock);
			try {
				$db = JFactory::getDBO();
				$query = sprintf("INSERT INTO #__opensim_offlinemessages (imSessionID,fromAgentID,fromAgentName,toAgentID,fromGroup,message,remoteip,sent) VALUES ('%s','%s','%s','%s','%s','%s','%s',NOW())",
						$message['imSessionID'],
						$message['fromAgentID'],
						$message['fromAgentName'],
						$message['toAgentID'],
						$message['fromGroup'],
						addslashes($msg),
						$data['remoteip']);
				$db->setQuery($query);
				$db->execute();
				$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>true</boolean>";

				// no need to check in components settings for offline messages since we would not be here if disabled
				$usersettings = $this->opensim->getUserSettings($message['toAgentID']);
				if($usersettings['im2email'] == 1) { // Send Email to "toAgentID" only if set in user settings
					$config		= JFactory::getConfig();
					if($message['fromGroup'] == "true") {
						$groupname	= getGroupName($message['fromAgentID']);
						$subject	= JText::sprintf(JOPENSIM_GROUPIM2MAILSUBJECT,$groupname,$config->get('fromname'))." (".$message['fromAgentName'].")";
						$dash		= strpos($message['message'],"|");
						if($dash) {
							$message['message'] = JText::_('JOPENSIM_GROUPNOTICE_SUBJECT').str_replace("|","\n\n",substr($message['message'],0,($dash+1))).substr($message['message'],($dash+1));
						}
					} else {
						$subject	= JText::_('IM2MAILSUBJECT')." ".$config->get('fromname')." (".$message['fromAgentName'].")";
					}
					$userdata	= $this->opensim->getUserData($message['toAgentID']);
					$mailer		= JFactory::getMailer();
					$sender		= array($config->get('mailfrom'),$config->get('fromname'));
					$body		= JText::_('IMFROM').": ".$message['fromAgentName']."\n\n".$message['message'];
					$mailer->setSender($sender);
					$mailer->addRecipient($userdata['email']);
					$mailer->setSubject($subject);
					$mailer->setBody($body);
					$mailer->Send();
				}
			} catch (Exception $e) {
				$errormsg = $e->getMessage();
				if($this->debug['messages'] == "1") $this->simpledebugzeile("error: ".$errormsg,$functionblock);
				$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
			}
		} else {
			if($this->debug['messages'] == "1") $this->simpledebugzeile("\nno message found in request",$functionblock);
			$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
		}
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->debugzeile("Response for saveMessage:\n\n".$retval,$functionblock);
		return $retval;
	}

	public function retrieveMessages($data) {
		$functionblock = "Offline Messages";
		if($this->debug['messages'] == "1") $this->simpledebugzeile("Offline Messages [RetrieveMessages] fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);

		$message	= $this->opensim->parseOSxml($data['input']);
		$guid		= $message['Guid'];
		$db			= JFactory::getDBO();
		$query		= sprintf("SELECT message FROM #__opensim_offlinemessages WHERE toAgentID = '%s' ORDER BY sent",
				$guid);
		$db->setQuery($query);
		$messages	= $db->loadRowList();
		$retval		= "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><ArrayOfGridInstantMessage xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">";
		foreach($messages AS $message) {
			$retval .= $message[0];
		}
		$retval .= "</ArrayOfGridInstantMessage>";
		$query = sprintf("DELETE FROM #__opensim_offlinemessages WHERE toAgentID = '%s'",$guid);
		$db->setQuery($query);
		$db->execute();
		if($this->debug['messages'] == "1") $this->debugzeile("Response for retrieveMessages:\n\n".$retval,$functionblock);
		return $retval;
	}

}
?>